#
# a simple class to store mountains
#
# attributes: name
#             elevation
#             prominence
#             latitude (tuple)
#             longitude (tuple)
#             climbed
#
# author: David Mathias
#

class Mountain():
    # class variable
    num_mountains = 0
    
    def __init__(self, name, elev, prom, lat, lon):
        self.name = name
        self.elevation = elev
        self.prominence = prom
        self.latitude = lat
        self.longitude = lon
        self.climbed = False
        Mountain.num_mountains += 1
        
    def __del__(self):
        Mountain.num_mountains -= 1
    
    
    # convert the object to a string and return it
    # invoked by casting the object to str
    def __str__(self):
        lat = self.latitude
        lon = self.longitude
        s = 'Name: ' + self.name + '\n'
        s += 'Elevation: ' + str(self.elevation) + '\n'
        s += 'Prominence: ' + str(self.prominence) + '\n'
        s += 'Latitude: ' + lat[0] + ':' + lat[1] + ':' + lat[2] + '\n'
        s += 'Longitude: ' + lon[0] + ':' + lon[1] + ':' + lon[2] + '\n'
        s += 'Climbed: ' + str(self.climbed) + '\n'
        return s

    
    # returns true if self has a greater elevation or 
    # an equal elevation and greater prominence
    # false otherwise
    def is_higher(self, m2):
        return ((self.elevation > m2.elevation) or (self.elevation == m2.elevation and self.prominence > m2.prominence))
    
    
    # set the climbed attribute for self
    def climb(self):
        self.climbed = True
        print('Congratlations, you climbed {}.  Here\'s your t-shirt.'.format(self.name))
    
    
    # pretty print the attributes of self
    def print_mtn(self):
        print('{:20s}  {:6d}  {:6d}  {:1d}:{:2d}:{:2d}  {:2d}:{:2d}:{:2d}   {}'.format(self.name,
              self.elevation, self.prominence, self.latitude[0], self.latitude[1], self.latitude[2],
              self.longitude[0], self.longitude[1], self.longitude[2], self.climbed))
    
    